<script setup lang="ts">
import {
  computed,
  isProxy,
  provide,
  readonly,
  ref,
  toRaw,
  watchEffect,
} from "vue";

import MeSHAutocomplete from "./MeSHAutocomplete.vue";
import MeSHTree from "./MeSHTree.vue";
import injectionSymbols from "./injectionSymbols";
import getAlgoWorker from "@/lib/get-worker.js";

import meshDescriptorsTree from "@/data/meshDescriptorsTree";
import {
  meshDescriptorList,
  meshDescriptorsFlat,
} from "@/data/meshDescriptorsFlat";
import translations from "../../language/translations.json";

import type {
  MeSHDescriptor,
  MeSHUI,
  SelectedMeSHDescriptor,
} from "@/types/mesh";
import type { Language } from "@/types/lang";

const props = withDefaults(
  defineProps<{
    itemUIs?: MeSHUI[][];
    lang?: Language;
  }>(),
  {
    lang: "en",
  },
);

const isTreeOpen = ref(false);

const meshDescriptorsSelectedDirectly = ref([] as MeSHDescriptor[]);
const meshDescriptorsSelectedTotal = ref([] as SelectedMeSHDescriptor[]);

// Provide to child components
provide(
  injectionSymbols.meshDescriptorsSelectedDirectly,
  meshDescriptorsSelectedDirectly,
);

provide(
  injectionSymbols.meshDescriptorsSelectedTotal,
  meshDescriptorsSelectedTotal,
);

// We want to provide a typed language ref to child components
const lang = ref(props.lang);
provide(injectionSymbols.language, lang);

watchEffect(() => {
  lang.value = props.lang;
});

const defaultPrefiltered = {
  tree: meshDescriptorsTree,
  descriptors: meshDescriptorList,
};
const prefiltered = ref(defaultPrefiltered);

watchEffect((onCleanup) => {
  if (!props.itemUIs || props.itemUIs.flat().length === 0) {
    prefiltered.value = defaultPrefiltered;
    return;
  }

  const itemUIs = (
    isProxy(props.itemUIs) ? toRaw(props.itemUIs) : props.itemUIs
  ).map((articleUIs: string[]) =>
    isProxy(articleUIs) ? toRaw(articleUIs) : articleUIs,
  );

  const { worker, wrapped } = getAlgoWorker();
  wrapped
    .prefilterTree(meshDescriptorsTree, itemUIs)
    .then((data) => {
      const { prefilteredTree, visibleNodes } = data;
      const prefilteredDescriptors = meshDescriptorList.filter((desc) =>
        visibleNodes.has(desc.ui),
      );
      prefiltered.value = {
        tree: prefilteredTree,
        descriptors: prefilteredDescriptors,
      };
    })
    .finally(() => {
      worker.terminate();
    });

  onCleanup(() => {
    worker.terminate();
  });
});

defineExpose({
  clear: () => {
    meshDescriptorsSelectedDirectly.value = [];
  },
  addByUi: (ui: MeSHUI) => {
    const descriptor = meshDescriptorsFlat[ui];
    if (!descriptor) {
      throw new Error(`No descriptor found for UI ${ui}`);
    }
    meshDescriptorsSelectedDirectly.value = [
      ...meshDescriptorsSelectedDirectly.value,
      descriptor,
    ];
  },
  removeByUi: (ui: MeSHUI) => {
    const descriptor = meshDescriptorsFlat[ui];
    if (!descriptor) {
      throw new Error(`No descriptor found for UI ${ui}`);
    }
    meshDescriptorsSelectedDirectly.value =
      meshDescriptorsSelectedDirectly.value.filter((i) => i.ui !== ui);
  },
  meshDescriptorsSelectedDirectly,
  meshDescriptorsSelectedTotal: readonly(meshDescriptorsSelectedTotal),
  meshUIsSelectedTotal: computed(
    () => new Set<MeSHUI>(meshDescriptorsSelectedTotal.value.map((i) => i.ui)),
  ),
});
</script>

<template>
  <div>
    <MeSHAutocomplete :descriptors="prefiltered.descriptors" />

    <o-collapse
      class="card mt-3"
      animation="slide"
      v-model:open="isTreeOpen"
      aria-id="toggleTreeView"
      renderless
    >
      <template #trigger>
        <div class="card-header" role="button">
          <p class="card-header-title">{{ translations[lang].treeView }}</p>
          <button class="card-header-icon" aria-controls="toggleTreeView">
            <o-icon
              icon="caret-down"
              :style="{
                transition: 'transform 250ms ease-in-out',
                transform: isTreeOpen ? 'rotate(180deg)' : 'rotate(0deg)',
              }"
            />
          </button>
        </div>
      </template>
      <div class="card-content p-4" :style="{ overflow: 'auto' }">
        <MeSHTree :tree="prefiltered.tree" />
      </div>
    </o-collapse>
  </div>
</template>

<style scoped>
button {
  background: none;
  border: none;
  padding: 0;
  font: inherit;
  cursor: pointer;
}
</style>
